<script>
import { ref } from "vue";

import { submit, rows, btnLoadingState } from "../composables/data";
let form = ref({
  name: "",
  username: "",
  email: "",
  address: {
    street: "",
    suite: "",
    city: "",
    zipcode: "",
    geo: {
      lat: "",
      lng: "",
    },
  },
  phone: "",
  website: "",
  company: {
    name: "",
    catchPhrase: "",
    bs: "",
  },
});
let userForm = ref(null);
export default {
  setup() {
    let columns = ref([
      {
        name: "id",
        label: "id",
        align: "left",
        field: "id",
      },
      {
        name: "name",
        label: "Name",
        align: "left",
        field: "name",
      },
      {
        name: "username",
        label: "Username",
        align: "left",
        field: "username",
      },
      {
        name: "email",
        label: "Email Address",
        align: "left",
        field: "email",
      },
      {
        name: "address",
        label: "Address",
        align: "left",
        field: "address",
        format: (value, row) =>
          `${row.address.street}, ${row.address.suite}, ${row.address.city} ${row.address.zipcode}`,
      },
      {
        name: "geo",
        label: "Geo",
        align: "left",
        field: "geo",
        format: (value, row) =>
          `lat: ${row.address.geo.lat}, long: ${row.address.geo.lng}`,
      },
      {
        name: "phone",
        label: "Phone Number",
        align: "left",
        field: "phone",
      },
      {
        name: "website",
        label: "Website",
        align: "left",
        field: "website",
      },
      {
        name: "company",
        label: "Company Name",
        align: "left",
        field: "company",
        format: (value, row) =>
          `${row.company.name} - ${row.company.catchPhrase} - ${row.company.bs}`,
      },
    ]);

    let rows = ref([]);

    let selectedRow = ref({});
    const onRowClick = (evt, row) => {
      selectedRow.value = row;
      form.value = { ...row };
    };

    return {
      form,
      rows,
      selectedRow,
      onRowClick,
      userForm,
      btnLoadingState,
      columns,
      submit,
    };
  },
};
export { form, userForm };
</script>

<template>
  <q-page class="q-ma-xl">
    <q-form ref="userForm" @submit="submit()" class="q-ma-md">
      <q-input
        stack-label
        dense
        outlined
        style="
          width: 500px;
          margin-top: 2px;
          margin-left: 450px;
          margin-right: 450px;
        "
        v-model="form.name"
        label="Name"
        :rules="[(val) => !!val || 'Required to fill.']"
      />
      <q-input
        stack-label
        dense
        outlined
        style="
          width: 500px;
          margin-top: 2px;
          margin-left: 450px;
          margin-right: 450px;
        "
        v-model="form.username"
        label="username"
        :rules="[(val) => !!val || 'Required to fill.']"
      />
      <q-input
        stack-label
        dense
        outlined
        style="
          width: 500px;
          margin-top: 2px;
          margin-left: 450px;
          margin-right: 450px;
        "
        v-model="form.email"
        label="Email Address"
        :rules="[(val) => !!val || 'Required to fill.']"
      />
      <q-input
        stack-label
        dense
        outlined
        style="
          width: 500px;
          margin-top: 2px;
          margin-left: 450px;
          margin-right: 450px;
        "
        v-model="form.address.street"
        label="Street"
        :rules="[(val) => !!val || 'Required to fill.']"
      />
      <q-input
        stack-label
        dense
        outlined
        style="
          width: 500px;
          margin-top: 2px;
          margin-left: 450px;
          margin-right: 450px;
        "
        v-model="form.address.suite"
        label="Suite"
        :rules="[(val) => !!val || 'Required to fill.']"
      />
      <q-input
        stack-label
        dense
        outlined
        style="
          width: 500px;
          margin-top: 2px;
          margin-left: 450px;
          margin-right: 450px;
        "
        v-model="form.address.city"
        label="City"
        :rules="[(val) => !!val || 'Required to fill.']"
      />
      <q-input
        stack-label
        dense
        outlined
        style="
          width: 500px;
          margin-top: 2px;
          margin-left: 450px;
          margin-right: 450px;
        "
        v-model="form.address.zipcode"
        label="Zipcode"
        :rules="[(val) => !!val || 'Required to fill.']"
      />
      <q-input
        stack-label
        dense
        outlined
        style="
          width: 500px;
          margin-top: 2px;
          margin-left: 450px;
          margin-right: 450px;
        "
        v-model="form.address.geo.lat"
        label="Lat"
        :rules="[(val) => !!val || 'Required to fill.']"
      />
      <q-input
        stack-label
        dense
        outlined
        style="
          width: 500px;
          margin-top: 2px;
          margin-left: 450px;
          margin-right: 450px;
        "
        v-model="form.address.geo.lng"
        label="Lng"
        :rules="[(val) => !!val || 'Required to fill.']"
      />
      <q-input
        stack-label
        dense
        outlined
        style="
          width: 500px;
          margin-top: 2px;
          margin-left: 450px;
          margin-right: 450px;
        "
        v-model="form.phone"
        label="Phone Number"
        :rules="[(val) => val.trim() !== '' || 'Required to fill.']"
      />
      <q-input
        stack-label
        dense
        outlined
        style="
          width: 500px;
          margin-top: 2px;
          margin-left: 450px;
          margin-right: 450px;
        "
        v-model="form.website"
        label="Website"
        :rules="[(val) => !!val || 'Required to fill.']"
      />
      <q-input
        stack-label
        dense
        outlined
        style="
          width: 500px;
          margin-top: 2px;
          margin-left: 450px;
          margin-right: 450px;
        "
        v-model="form.company.name"
        label="Company Name"
        :rules="[(val) => !!val || 'Required to fill.']"
      />
      <q-input
        stack-label
        dense
        outlined
        style="
          width: 500px;
          margin-top: 2px;
          margin-left: 450px;
          margin-right: 450px;
        "
        v-model="form.company.catchPhrase"
        label="Catch Phrase"
        :rules="[(val) => !!val || 'Required to fill.']"
      />
      <q-input
        stack-label
        dense
        outlined
        style="
          width: 500px;
          margin-top: 2px;
          margin-left: 450px;
          margin-right: 450px;
        "
        v-model="form.company.bs"
        label="Bs"
        :rules="[(val) => !!val || 'Required to fill.']"
      />
      <q-btn
        :loading="btnLoadingState"
        icon="check"
        type="submit"
        label="Submit"
        color="green"
        style="
          width: 500px;
          margin-top: 20px;
          margin-left: 450px;
          margin-right: 450px;
        "
      />
    </q-form>
  </q-page>
</template>
